unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SHDocVw_TLB, ExtCtrls, IEAddress, EditPlugAPI,
  Buttons, AppEvnts;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    browser: TWebBrowser_V1;
    Panel2: TPanel;
    Panel3: TPanel;
    IEAddress1: TIEAddress;
    Panel4: TPanel;
    bRefresh: TButton;
    bStop: TButton;
    bForward: TButton;
    bBack: TButton;
    sbStayOnTop: TSpeedButton;
    procedure cbAddressKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bStopClick(Sender: TObject);
    procedure bBackClick(Sender: TObject);
    procedure bForwardClick(Sender: TObject);
    procedure browserCommandStateChange(Sender: TObject; Command: Integer;
      Enable: WordBool);
    procedure IEAddress1UpdateText(Sender: TObject; OldUrl,
      NewUrl: WideString; var Cancel: Boolean);
    procedure IEAddress1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bRefreshClick(Sender: TObject);
    procedure IEAddress1Click(Sender: TObject);
    procedure NavigateToUrl(url: string);
    procedure browserNavigateComplete(Sender: TObject;
      const URL: WideString);
    procedure sbStayOnTopClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  gPlugId: HINST;

implementation

{$R *.DFM}

{ EXPORTS ---------------------------------------------------------------------}

procedure plgSetId(id: HINST); cdecl;
begin
  gPlugId:= id;
end; exports plgSetId;

function plgShow: HWND; cdecl;
var
  url: string;
  rect: TRect;
begin
  if not assigned(form1) then begin
    form1:= tform1.create(nil);
    epSetParentToMainWin(form1.handle);
    form1.show;
    epMoveWinToTopRight(form1);
    rect := GetDesktopPos(form1.handle);
    setparent(form1.handle, 0);
    SetDesktopPos(form1.handle, rect, form1.Width, form1.height);
  end else begin
    form1.show;
  end;
  if epActiveEdUnnamed then begin
    if epGetActiveEdTmpHtmFileLen < 1 then
      epMakeActiveEdTmpHtmFile
    else
      epSaveActiveEdTmpHtmFile;
    url := epGetActiveEdTmpHtmFileAsString;
  end else begin
    epSaveActiveEdFile;
    url := epGetActiveEdFilenameAsString;
  end;
  form1.NavigateToURL(url);
  // this refresh causes problems, leave out
  //  form1.bRefreshClick(nil);
  result:= form1.Handle;
end; exports plgShow;

procedure plgWinFree; cdecl;
begin
  if assigned(form1) then begin
    form1.Free;
    form1:=nil;
  end;
end; exports plgWinFree;

function plgGetWinHandle: HWND; cdecl;
begin
  result:=0;
  if assigned(form1) then result:= form1.Handle;
end; exports plgGetWinHandle;

{------------------------------------------------------------------------------}

procedure TForm1.NavigateToUrl(url: string);
begin
  IEAddress1.text := url;
  form1.IEAddress1Click(nil);
//  browser.Navigate(IEAddress1.text);
end;


procedure TForm1.cbAddressKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then begin
    browser.Navigate(IEAddress1.text);
  end;
end;

procedure TForm1.bStopClick(Sender: TObject);
begin
  browser.Stop;
end;

procedure TForm1.bBackClick(Sender: TObject);
begin
  browser.GoBack;
end;

procedure TForm1.bForwardClick(Sender: TObject);
begin
  browser.GoForward;
end;

procedure TForm1.browserCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  case Command of
    CSC_NAVIGATEBACK: bBack.Enabled := Enable;
    CSC_NAVIGATEFORWARD: bForward.Enabled := Enable;

  end;
end;

procedure TForm1.IEAddress1UpdateText(Sender: TObject; OldUrl,
  NewUrl: WideString; var Cancel: Boolean);
begin
  browser.Navigate(IEAddress1.Text);
end;

procedure TForm1.IEAddress1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then browser.Navigate(IEAddress1.Text);
  if key = 8 then begin
    ieAddress1.Repaint ;
    ieAddress1.Invalidate;
  end;
  if key = 46 then begin
    ieAddress1.Repaint;
    ieAddress1.Invalidate;
  end;
end;

procedure TForm1.bRefreshClick(Sender: TObject);
begin
  if browser.LocationURL <> '' then
    if browser.LocationURL <> 'about:blank' then
      browser.Refresh();
end;

procedure TForm1.IEAddress1Click(Sender: TObject);
begin
  browser.Navigate(IEAddress1.Text);
end;

procedure TForm1.browserNavigateComplete(Sender: TObject;
  const URL: WideString);
begin
  ieaddress1.text := browser.LocationURL;
end;

procedure TForm1.sbStayOnTopClick(Sender: TObject);
begin
  if sbStayOnTop.Down then
    self.FormStyle := fsStayOnTop
  else
    self.FormStyle := fsNormal;
  browser.Navigate(IEAddress1.Text);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then begin
    key := 0;
    Close;
  end;

  if (Key = 69) {E} and (Shift = [ssCtrl]) then begin
    key := 0;
    close;
  end;

  if (Key = 66) {B} and (Shift = [ssCtrl]) then begin
    key := 0;
    close;
  end;
end;

end.
